;
; IDL Event Callback Procedures
; MSP_PPT_eventcb
;
; Generated on:	01/16/2020 22:38.18
;
;
; DPC   v1.4   20210726 - added log(P) vector lengths
;
pro MSP_PPT_eventcb
end
;-----------------------------------------------------------------
; Notify Realize Callback Procedure.
; Argument:
;   wWidget - ID number of specific widget.
;
;
;   Retrieve the IDs of other widgets in the widget hierarchy using
;       id=widget_info(Event.top, FIND_BY_UNAME=name)

;-----------------------------------------------------------------
pro PPT_Realize, wWidget
	;
	;	get key window information
	;
	WIDGET_CONTROL, wWidget, GET_UVALUE=PTR
	;
;	;	need to pass an event structure:
;	;
	event = {top: wWidget}
	;
	;	main base - change name
	;
	wid_tlb = WIDGET_INFO(wWidget, find_by_uname="PPT_TLB")
	title = 'Mimir Software Package - Polarization Plotting Tool (MSP_PPT) '
	title += 'V1.4 20210726'
	WIDGET_CONTROL, wid_tlb, BASE_SET_TITLE=title
	;
	;	window type
	;
	(*PTR).win_type = !D.name
	;
	;	set color table
	;
	device, decomposed=0
	;
	loadct, 0, /silent	; gray scale LUT
	;
	n_off = 0
	;
	tvlct, [0, 255, 255,   0,   0, 100, 255, 128, 255,128,64,192], $
		     [0, 255,   0, 255,   0, 200,   0, 128, 255,128,64,192], $
		     [0, 255,   0,   0, 255, 200, 255,   0,   0,128,64,192], n_off
	color_names = ['black','white','red','green','blue','cyan','magenta','olive','yellow','gray','gray-dk','gray-lt']
	colors = [0,1,2,3,4,5,6,7,8,9,10,11] + n_off
	;
	(*PTR).color_names = color_names
	(*PTR).colors = colors
	;
	(*PTR).reference_lengths = ['0.5%','1.0%','1.5%','2.0%','2.5%','3.0%','4.0%','5.0%','No Ref. Vec.']
	(*PTR).reference_length_index = 1L
	;
	(*PTR).vector_lengths = ['1 pixel','2 pixels','3 pixels','5 pixels','7 pixels','10 pixels','15 pixels','20 pixels','25 pixels','30 pixels','35 pixels',$
								'40 pixels']
	(*PTR).vector_length_index = 6L
	;
	(*PTR).vector_thicknesses = ['1','2','3','4']
	(*PTR).vector_thickness_index = 0L
	;
	(*PTR).circle_radii = ['2 pixels', '5 pixels','8 pixels','10 pixels','15 pixels','20 pixels']
	(*PTR).circle_radius_index = 2L
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME='Droplist_Upper_Radius')
	WIDGET_CONTROL, wid_id, SET_VALUE = (*PTR).circle_radii
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT = (*PTR).circle_radius_index
	;
	(*PTR).circle_thicknesses = ['1','2','3','4']
	(*PTR).circle_thickness_index = 0L
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME='Droplist_Upper_Thickness')
	WIDGET_CONTROL, wid_id, SET_VALUE = (*PTR).circle_thicknesses
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).circle_thickness_index
	;
	(*PTR).split_LowP_Faint_flag = 1L	; default, don't split upper limits by LowP/faint
	Toggle_Split_Upper_Limits, Event
	;
	(*PTR).show_upper_flag = 1L			; default, don't show upper limits
	Toggle_Show_Circles, Event
	;
	;	Tab 2 color selections
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_T2_Selected_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_t2_selected = 2L				; color index for the selected stars
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).color_t2_selected
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_T2_LowP_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_t2_lowP =	3L					; color index for the low-P stars
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).color_t2_lowP
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_T2_Faint_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_t2_faint = 4L					; color index for the faint stars
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).color_t2_faint
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Divider_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_dividers = 6L					; color index for the faint stars
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).color_dividers
	;
	;	Tab 3 color selections
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Faint_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_faint = 11L				; color index for faint (or all) upper limits
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).color_faint
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_High_LowP_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_LowP_high = 2L			; color index for LowP, high -log(PSNR) stars
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).color_LowP_high
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Med_LowP_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_LowP_med = 4L			; color index for LowP, medium -log(PSNR) stars
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).color_LowP_med
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Low_LowP_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_LowP_low = 9L
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).color_LowP_low
	;
	;	gray out some options
	;
	Toggle_Length_Pol, Event
	;
	Toggle_Color_PSNR, Event
	;
	(*PTR).plot_title_flag = 0
	Toggle_Plot_Title, Event
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME='Text_Plot_Offset')
	WIDGET_CONTROL, wid_id, SET_VALUE=STRING((*PTR).offset,format='(f5.2)')
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME='Text_Plot_Range')
	WIDGET_CONTROL, wid_id, SET_VALUE=STRING((*PTR).range,format='(f5.2)')
	;
	;	set color names in droplists
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_lt_2")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).colors_PSNR[0] = 5
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=5
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_2")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).colors_PSNR[1] = 6
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=6
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_3")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).colors_PSNR[2] = 7
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=7
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_5")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).colors_PSNR[3] = 8
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=8
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_7")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).colors_PSNR[4] = 4
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=4
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_10")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).colors_PSNR[5] = 3
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=3
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Reference_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_reference = 6
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=6
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Uniform_Color")
	WIDGET_CONTROL, wid_id, SET_VALUE=color_names
	(*PTR).color_uniform = 5
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=5
	;
	;	and reference lengths
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Reference_Length")
	WIDGET_CONTROL, wid_id, SET_VALUE=(*PTR).reference_lengths
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).reference_length_index
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Vector_Length")
	WIDGET_CONTROL, wid_id, SET_VALUE=(*PTR).vector_lengths
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).vector_length_index
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Vector_Thickness")
	WIDGET_CONTROL, wid_id, SET_VALUE=(*PTR).vector_thicknesses
	WIDGET_CONTROL, wid_id, SET_DROPLIST_SELECT=(*PTR).vector_thickness_index
	;
	;	clear plot windows
	;
	plot1_wid = WIDGET_INFO(Event.top, FIND_BY_UNAME="Draw_PSNR_vs_mH")
	WIDGET_CONTROL, plot1_wid, GET_VALUE=win_1
	wset, win_1
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'Window 1',alignment=0.5
	;
	plot2_wid = WIDGET_INFO(Event.top, FIND_BY_UNAME="Draw_sP_vs_mH")
	WIDGET_CONTROL, plot2_wid, GET_VALUE=win_2
	wset, win_2
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'Window 2',alignment=0.5
	;
	plot3_wid = WIDGET_INFO(Event.top, FIND_BY_UNAME="Draw_Final_Plot")
	WIDGET_CONTROL, plot3_wid, GET_VALUE=win_3
	wset, win_3
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'Window 3',alignment=0.5
	;
	;	erase it and write a message there
	;
	zprint,event,' '
	zprint,event,' '
	zprint,event,' '
	zprint,event,'Mimir Software Package:'
	zprint,event,'Polarization Plotting Tool'
	zprint,event,'V1.4  20210726'
	zprint,event,'Initialized'
	zprint,event,' '
	zprint,event,'-- Hello, Doctor. Would you like to play a game?'
end
;-----------------------------------------------------------------
pro PPT_PostCreation, wWidget, _EXTRA=_VWBExtra_
	;
    ;   set up and clear main structure
    ;
    main_struct =  {win_type:	'', $					; window manager type
    				current_tab:	0L, $				;current displayed tab for top level base tab
    				t1_current_tab:	0L,	$				; same for tab base on T1
					;
					ppol_dir:	    '', $				;top-level PPOL directory
					;
					files_deep:	   strarr(300),$		; list of Deep_Coadd files in Coadd directory
					ndeep:			0L,$				; number of such files
					this_deep:		0L,$				; currently selected one (starting from 0)
					;
					image_ptr:		ptr_new(/alloc),$ 	; 	pointer to image array
					header_ptr:		ptr_new(/alloc),$	; 	same, for header
					image_read_flag:	0L, $			; set if an image has been read
					image_name:			'', $			; the root name of the image that was read in
					;
					polcat_compares: strarr(100),$		; polcat pathnames for comparison
					n_polcat_compares:	0L, $			; number of polcats to compare
					;
					polcat_merges: strarr(100),$			; polcat pathnames for merging
					n_polcat_merges:	0L, $			; number of polcats to merge
					;
					uniform_length_flag: 0L, $			; if set, vector lengths are uniform
					pol_length_flag: 	 0L, $			; if set, vector lengths proportional to polarization percentage
					pol_log_flag:      0L, $      ; if set, vector lengths proportional to log of P%
					;
					;	color indices for vectors, by PSNR limits
					;
					colors_PSNR:			lonarr(6), $	; color indices for PSNR > 2, 3, 5, 7, 10 respectively
					color_PSNR_flag:	0L,$			; if set, vector colors change with PSNR
					;
					color_uniform:		0L, $ 			; color index for uniform vector color
					color_uniform_flag:	0L, $			; if set, vector colors are uniform
					;
					color_reference:	0L, $			; color of the reference vector
					reference_lengths: ['0.5%','1.0%','1.5%','2.0%','2.5%','3.0%','4.0%','5.0%','No Ref. Vec.'],$ ;
					reference_length_index: 1L, $		; index for ref length
					;
 					color_names:	strarr(12),$		  	; names of plotting colors
          colors:			intarr(12),$		  	; corresponding color numbers
          ;
          vector_lengths: strarr(12),$			; vector length scaling options
					vector_length_index: 6L, $			; index into above
					;
					vector_thicknesses: strarr(4),$		; DS9 thickness choices
					vector_thickness_index: 1L, $		; index for above
					;
					chsz:					1.0,$		; plotting character size
					thick:					1.0,$		; plotting line, character thickness
					;
					;	Tab 2 plotting colors
					;
					color_t2_selected:		0L,$		; color index for the selected stars
					color_t2_lowP:			0L,$		; color index for the low-P stars
					color_t2_faint:			0L,$		; color index for the faint stars
					color_dividers:			0L,$		; color index for the vertical and horizontal dividing lines
					;
					;	upper limits parameters
					;
					show_upper_flag:		0L,$		; 0 = don't show upper limits, 1 = show upper limits
					;
					split_LowP_Faint_flag:	0L,$		; 0 = treat all upper limits the same, 1 = separate LowP from Faint stars
					;
					color_faint:			0L,$		; color index for faint (or all) upper limits
					color_LowP_high:		0L,$		; color index for LowP, high -log(PSNR) stars
					color_LowP_med:			0L,$		; color index for LowP, medium -log(PSNR) stars
					color_LowP_low:			0L,$		; color index for LowP, low -log(PSNR) stars
					;
					circle_radii: strarr(9), $			; radii of upper limit circles
					circle_radius_index: 2L, $			; index into above
					;
					circle_thicknesses: strarr(4),$		; DS9 thickness choices
					circle_thickness_index: 1L, $		; index for above
					;
					;
					file_out:			'',$			; pathname to which POLCAT will be written
					;
					recent_merge_flag: 0L, $			; if set, the most recent action was a merger and the file_out
														; pathname still points to that merged file
					recent_combine_flag: 0L, $			; if set, the most recent action was a combination file and the
														; file_out pathname still points to that combined file
					analysis_polcat_path:  '',$			; path to the POLCAT to analyze (of any type)
					;
					is_polcat_flag:			0L,$		; if set, the POLCAT read in is standard POLCAT type (not merged)
					is_merged_flag:			0L,$		; if set, the POLCAT read in is a merged POLCAT type (not single)
					;
					polcat_data:	ptr_new(/alloc),$	; pointer to polcat data structure
					;
					;	selection criteria
					;
					max_mag:				13.3,$		; maximum allowed magnitude
					min_psnr:				2.0,$		; minimum allowed PSNR
					max_sp:					0.75,$		; maximum allowed sP
					;
					;	indices for the POLCAT being analyzed
					;
					ind_select: lonarr(100000L), $
					n_select: 				0L, $
					ind_reject: lonarr(100000L), $
					n_reject:				0L, $
					;
					;	plot parameters
					;
					offset:					2.0,  $		; log(counts) zero offset for plot
					range:					3.0,  $		; log(counts) range for plot
					plot_title_flag:		1,	  $		; flag for printing filename as plot title
					ps_out:					'',	  $		; postscript path to write
					ps_thick:				1.0,  $		; thickness multiplier for PS files
					;
					vectors_ptr:		PTR_new(/alloc),	$	; pointer of vectors to draw
					;
					circles_ptr:		PTR_new(/alloc)		$	; pointer of circles to draw
					;
					;=================================
                    }
    ;
	;
	;------------------------------------------------------------------------
    ;
    PTR = PTR_NEW(main_struct,/NO_COPY)
    ;
    WIDGET_CONTROL, wWidget, SET_UVALUE=PTR
end
;-----------------------------------------------------------------
function get_color, Event, name
	;
	;	returns color index, given name
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	ind = WHERE(name eq (*PTR).color_names,n)
	if(n eq 1) then begin
		clr = ind[0]+(*PTR).colors[0]
	endif else begin
		clr = -1
	endelse
	;
;	print, 'in get_color, name = ',name,' returned index = ',clr
	;
	return, clr
end
;
;-----------------------------------------------------------------
pro PPT_Tab_Change, Event
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO( Event.top, FIND_BY_UNAME="PPT_Tabs")
	;
	; which tab is front?
	;
	this_tab = WIDGET_INFO( wid_id, /TAB_CURRENT)
	;
	zprint,event,'Moved to Tab '+string(this_tab+1,format='(I2)')
	;
	(*PTR).current_tab = this_tab + 1
	;
	case this_tab of
		0:
		1: Tab_2_Handler,event
		2:
		3: Tab_4_Handler, event
	endcase
end
;
;-----------------------------------------------------------------
pro Select_PPOL_Dir, Event
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO( Event.top, FIND_BY_UNAME="Button_Select_PPOL_Directory")
	;
	zprint,event,'Selecting PPOL Directory'
	;
	ppol_dir = dialog_pickfile(title='Select PPOL Top-Level Directory',/dir)
	;
	(*PTR).ppol_dir = ppol_dir
	;
	zprint,event,'Selected '+ppol_dir
	;
	;	put into window
	;
	wid_id = WIDGET_INFO( Event.top, FIND_BY_UNAME="Text_PPOL_Directory")
	;
	WIDGET_CONTROL, wid_id, SET_VALUE=ppol_dir
	;
	;	next, go find the S7_Coadding directory and make a list of all the
	;	Deep_Coadd files, with that name removed
	;
	coadd_dir = ppol_dir + 'S7_Coadding' + PATH_SEP()
	;
	files = FILE_SEARCH(coadd_dir,'*.fits')
	nfiles = N_ELEMENTS(files)
	files = FILE_BASENAME(files)
	;
	zprint,event,'Found '+string(nfiles,format='(I)')+' total FITS files'
	;
	;	which are Deep_Coadds?
	;
	files_deep = strarr(1)
	ndeep = 0
	;
	for i = 0, nfiles-1 do begin
		ind = STRPOS(files[i],'Deep_Coadd')
		if(ind ne -1) then begin
			len = STRLEN(files[i])
			if(ndeep gt 0) then files_deep = [files_deep,'']
			files_deep[ndeep] = STRMID(files[i],0,ind-1)
			ndeep++
			;
		endif
	endfor
	;
	zprint,event,'  of which '+string(ndeep,format='(I)')+' were Deep_Coadd types'
	;
	; 	save and display in the list
	;
	(*PTR).files_deep[0:(ndeep-1)] = files_deep[*]
	(*PTR).ndeep = ndeep
	(*PTR).this_deep = 0		; select first one, just cuz
	;
	;
	wid_id = WIDGET_INFO( Event.top, FIND_BY_UNAME="List_Images")
	;
	WIDGET_CONTROL, wid_id, SET_VALUE=files_deep
	;
end
;
;-----------------------------------------------------------------
pro PPT_Exit_Asserted, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	; free the pointer
	;
	PTR_FREE, PTR
	;
	WIDGET_CONTROL, Event.top, /DESTROY
end
;
;-----------------------------------------------------------------
pro Image_Select, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="List_Images")
	;
	;	image was selected, which one?
	;
	sel_id = WIDGET_INFO(wid_id, /LIST_SELECT)
	;
	zprint,event,'Selected item number '+string(sel_id,format='(I)')
	;
	;	which image?
	;
	this_image = (*PTR).files_deep[sel_id]
	(*PTR).this_deep = sel_id
	;
	zprint,event,'  which is image '+this_image
	;
	;	read the image
	;
	this_path = (*PTR).ppol_dir + 'S7_Coadding' + PATH_SEP() + this_image + '_Deep_Coadd.fits'
	;
	zprint,event,'Path ='+this_path
	;
	(*(*PTR).image_ptr) = readfits(this_path,header)
	(*(*PTR).header_ptr) = header
	(*PTR).image_read_flag = 1L
	(*PTR).image_name = FILE_BASENAME(this_path,'.fits')
	;
	zprint,event,'Image read in'
	;
end
;
;-----------------------------------------------------------------
pro T1_Tab_Change, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO( Event.top, FIND_BY_UNAME="Tab1_Tab_Base")
	;
	; which tab is front?
	;
	this_tab = WIDGET_INFO( wid_id, /TAB_CURRENT)
	;
	zprint,event,'Moved on T1 to sub-Tab '+string(this_tab+1,format='(I2)')
	;
	(*PTR).t1_current_tab = this_tab + 1
	;
end
;
;-----------------------------------------------------------------
pro Select_Merge_POLCATs, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	;	go to the POLCATs subdirectory and select the files to compare
	;
	dir_path = (*PTR).ppol_dir + "S9_POLCAT_Entries"
	;
	;	if this directory doesn't exist, just use ppol_dir
	;
	test = FILE_INFO(dir_path)
	if(test.exists eq 0) then dir_path = (*PTR).ppol_dir
	;
	polcat_files = dialog_pickfile(title="Select POLCAT files to merge",$
					/multiple, PATH=dir_path)
	;
	npolcats = N_ELEMENTS(polcat_files)
	;
	if(npolcats gt 0) then begin
		;
		(*PTR).polcat_merges[0:(npolcats-1)] = polcat_files[*]
		(*PTR).n_polcat_merges = npolcats
		;
		zprint,event,'Selected '+string(npolcats,format='(I)')+' POLCATs for merging'
		;
	endif
	;
	wid_id = WIDGET_INFO( Event.top, FIND_BY_UNAME="Text_N_Merge_POLCATs")
	;
	WIDGET_CONTROL, wid_id, SET_VALUE=string(npolcats,format='(I)')
	;
end
;
;-----------------------------------------------------------------
pro Merge_POLCATs, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	ppt_merge_polcats,event
	;
	(*PTR).recent_merge_flag = 1
	(*PTR).recent_combine_flag = 0
	;
end
;
;-----------------------------------------------------------------
pro Name_Merged_POLCAT, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	this_dir = (*PTR).ppol_dir + 'S9_POLCAT_Entries'
	;
	;	if this directory doesn't exist, just use ppol_dir
	;
	test = FILE_INFO(this_dir)
	if(test.exists eq 0) then this_dir = (*PTR).ppol_dir
	;
	(*PTR).file_out = dialog_pickfile(title='Name of Merged POLCAT to save',$
						PATH=this_dir)
	;
	zprint,event,'Naming output POLCAT = '+(*PTR).file_out
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_Saved_Merged_POLCAT_Name")
	;
	WIDGET_CONTROL, wid_id, SET_VALUE=FILE_BASENAME((*PTR).file_out)
	;
end
;
;-----------------------------------------------------------------
pro Select_POLCATs_to_Compare, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	;	go to the POLCATs subdirectory and select the files to compare
	;
	this_dir = (*PTR).ppol_dir + "S9_POLCAT_Entries"
	;
	;	if this directory doesn't exist, just use ppol_dir
	;
	test = FILE_INFO(this_dir)
	if(test.exists eq 0) then this_dir = (*PTR).ppol_dir
	;
	polcat_files = dialog_pickfile(title="Select POLCAT files to compare",$
					/multiple,PATH=dir_path)
	;
	npolcats = N_ELEMENTS(polcat_files)
	;
	if(npolcats gt 0) then begin
		;
		(*PTR).polcat_compares[0:(npolcats-1)] = polcat_files[*]
		(*PTR).n_polcat_compares = npolcats
		;
		zprint,event,'Selected '+string(npolcats,format='(I)')+' POLCATs for comparing'
		;
	endif
	;
	wid_id = WIDGET_INFO( Event.top, FIND_BY_UNAME="Text_N_Comparison_POLCATs")
	WIDGET_CONTROL, wid_id, SET_VALUE=String(npolcats,format='(I)')
	;
end
;
;-------------------------------------------------------------------------
pro Select_Combined_POLCAT_Name, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	this_dir = (*PTR).ppol_dir + 'S9_POLCAT_Entries'
	;
	;	if this directory doesn't exist, just use ppol_dir
	;
	test = FILE_INFO(this_dir)
	if(test.exists eq 0) then this_dir = (*PTR).ppol_dir
	;
	(*PTR).file_out = dialog_pickfile(title='Name of Combined POLCAT to save',$
						PATH=this_dir)
	;
	zprint,event,'Naming combined POLCAT = '+(*PTR).file_out
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_Output_Combined_POLCAT")
	;
	WIDGET_CONTROL, wid_id, SET_VALUE=FILE_BASENAME((*PTR).file_out)
	;
end
;-----------------------------------------------------------------
pro Compare_POLCATs, Event
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	ppt_compare_polcats, event
	;
	(*PTR).recent_merge_flag = 0
	(*PTR).recent_combine_flag = 1
	;
end
;
;-----------------------------------------------------------------
pro Select_Analysis_POLCAT, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	this_dir = (*PTR).ppol_dir + 'S9_POLCAT_Entries'
	;
	;	if this directory doesn't exist, just use ppol_dir
	;
	test = FILE_INFO(this_dir)
	if(test.exists eq 0) then this_dir = (*PTR).ppol_dir
	;
	(*PTR).analysis_polcat_path = dialog_pickfile(title='Name of POLCAT to analyze',$
						PATH=this_dir)
	;
	zprint,event,'Naming POLCAT for Analysis = '+(*PTR).analysis_polcat_path
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_Analysis_POLCAT")
	;
	WIDGET_CONTROL, wid_id, SET_VALUE=FILE_BASENAME((*PTR).analysis_polcat_path)
	;
	;	test type of POLCAT
	;
	test_POLCAT_type,event
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_POLCAT_Type")
	str = 'Single'
	if((*PTR).is_merged_flag eq 1) then str = 'Merged'
	WIDGET_CONTROL, wid_id, SET_VALUE=str
	;
end
;
;--------------------------------------------------------------------
pro Tab_2_Handler, Event
	;
	; on Tab 2 - start by reading the correct POLCAT and type, then
	;	drawing the two plots
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	;	load the criteria fields
	;
	wid_mag = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_Mag_Limit")
	WIDGET_CONTROL, wid_mag, SET_VALUE=string((*PTR).max_mag,format='(F4.1)')
	;
	wid_psnr = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_PSNR_Limit")
	WIDGET_CONTROL, wid_psnr, SET_VALUE=string((*PTR).min_psnr,format='(F4.2)')
	;
	wid_spa = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_sPA_Limit")
	max_spa = 26.65/sqrt((*PTR).min_psnr^2-1.0)
	WIDGET_CONTROL, wid_spa, SET_VALUE=string(max_spa,format='(F5.2)')
	;
	wid_sp = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_sP_Limit")
	WIDGET_CONTROL, wid_sp, SET_VALUE=string((*PTR).max_sp,format='(F5.2)')
	;
	;	and the name field
	;
	wid_polcat = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_This_POLCAT")
	WIDGET_CONTROL, wid_polcat, SET_VALUE=FILE_BASENAME((*PTR).analysis_polcat_path)
	;
	no_data = 0
	if((*PTR).is_polcat_flag eq 1) then begin
		(*(*PTR).polcat_data) = ppt_read_polcat((*PTR).analysis_polcat_path)
		zprint, event, 'Read '+string(N_ELEMENTS((*(*PTR).polcat_data).s.H_mag),format='(I)')+' stars from single POLCAT'
	endif else begin
		if((*PTR).is_merged_flag eq 1) then begin
			(*(*PTR).polcat_data) = ppt_read_merged_polcat((*PTR).analysis_polcat_path)
			zprint, event, 'Read '+string(N_ELEMENTS((*(*PTR).polcat_data).s.H_mag),format='(I)')+' stars from merged POLCAT'
		endif else begin
			no_data = 1
		endelse
	endelse
	;
	;	ready plot 1
	;
	plot1_wid = WIDGET_INFO(Event.top, FIND_BY_UNAME="Draw_PSNR_vs_mH")
	WIDGET_CONTROL, plot1_wid, GET_VALUE=win_1
	wset, win_1
	erase
	;
	if(no_data eq 0) then begin
		type = 0
		Plot_PSNR_vs_mH, Event, type
	endif
	;
	;	second plot
	;
	plot2_wid = WIDGET_INFO(Event.top, FIND_BY_UNAME="Draw_sP_vs_mH")
	WIDGET_CONTROL, plot2_wid, GET_VALUE=win_2
	wset, win_2
	erase
	;
	if(no_data eq 0) then begin
		type = 0
		Plot_sP_vs_mH, Event, type
		;
		stokes_u = (*(*PTR).polcat_data).s.u
		stokes_q = (*(*PTR).polcat_data).s.q
		sP = (*(*PTR).polcat_data).s.sP
		mH = (*(*PTR).polcat_data).s.H_mag
		;
		psnr = sqrt(stokes_u^2 + stokes_q^2) / sP
		;
		ind_select = WHERE(mH le (*PTR).max_mag $
						and sP le (*PTR).max_sp $
						and psnr ge (*PTR).min_psnr,n_select,$
					COMPLEMENT=ind_reject,NCOMPLEMENT=n_reject)
		;
		;	upper limits and false positives
		;
		ind_upper = WHERE(mH le (*PTR).max_mag and sP le (*PTR).max_sp and psnr lt (*PTR).min_psnr,n_upper)
		ind_false = WHERE(mH gt (*PTR).max_mag and sP le (*PTR).max_sp and psnr ge (*PTR).min_psnr,n_false)
		;
		;	Low-P and faint
		;
		ind_LowP = WHERE(mH le (*PTR).max_mag $
					and  psnr lt (*PTR).min_psnr $
          and  sP le (*PTR).max_sp,n_LowP)
		ind_faint = WHERE(sP gt (*PTR).max_sp $
	            or    mH gt (*PTR).max_mag,n_faint)
	    ;
		;	update the selected and rejected POLCAT data pointers and counts
		;
		zprint, event, 'Selected '+STRING(n_select,format='(I)')+' and rejected '+STRING(n_reject,format='(I)')+' stars'
		;
		(*PTR).ind_select[0:(n_select - 1)] = ind_select
		(*PTR).n_select = n_select
		if(n_reject gt 0) then (*PTR).ind_reject[0:(n_reject - 1)] = ind_reject
		(*PTR).n_reject = n_reject
		;
		wid_id_select = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_Selected_Stars")
		wid_id_reject = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_Rejected_Stars")
		;
		WIDGET_CONTROL, wid_id_select, SET_VALUE=string(n_select,format='(I)')
		WIDGET_CONTROL, wid_id_reject, SET_VALUE=string(n_reject,format='(I)')
		;
		wid_id_upper = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_Upper")
		wid_id_false = WIDGET_INFO(Event.top, FIND_BY_UNAME="Text_False")
		;
;		WIDGET_CONTROL, wid_id_upper, SET_VALUE=string(n_upper,format='(I)')
;		WIDGET_CONTROL, wid_id_false, SET_VALUE=string(n_false,format='(I)')
		;
		WIDGET_CONTROL, wid_id_upper, SET_VALUE=string(n_LowP,format='(I)')
		WIDGET_CONTROL, wid_id_false, SET_VALUE=string(n_faint,format='(I)')
		;
	endif
	;
end
;
;----------------------------------------------------------------
pro Plot_sP_vs_mH, Event, type
	;
	;	creates the sP vs mH plot
	;
	;	if type = 0, sends it to the current window
	;	if type = 1, sends it to the output file (PS plot) and then resets to current WIN mode
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	if(type eq 1) then begin
		;
		;	capture current window type
		;
		SET_PLOT, 'PS'
		!P.FONT=1
		DEVICE, /TIMES, FONT_SIZE=13, /PORTRAIT, /ENCAPSUL, /COLOR, $
				XSIZE=24, YSIZE=22
		;
		DEVICE, FILENAME=(*PTR).ps_out
		;chsz = 2.25
		chsz = 1.4      ; 20210623
		thick=4
		pthick = 6
		xmar = [7,3]
		ymar = [10,3]
		;
		yt ='Log!D2!N(!9s!X!DP!N)'
;		(*PTR).ps_thick=ps_thick
;		(*PTR).chsz = chsz
;		(*PTR).thick = thick
		;
	endif
	;
	;
	if(type eq 0) then begin
		plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
		xyouts, 0.5, 0.5, 'Ready Window 1',alignment=0.5
		pthick=1
		chsz=1.3
		xmar = [8,1.5]
		ymar = [4,1]
		yt ='Base 2 Log of sP [%]'
		erase
	endif

	stokes_u = (*(*PTR).polcat_data).s.u
	stokes_q = (*(*PTR).polcat_data).s.q
	sP = (*(*PTR).polcat_data).s.sP
	mH = (*(*PTR).polcat_data).s.H_mag
	;
	psnr = sqrt(stokes_u^2 + stokes_q^2) / sP
	;
	ind_select = WHERE(mH le (*PTR).max_mag $
					and sP le (*PTR).max_sp $
					and psnr ge (*PTR).min_psnr,n_select,$
				COMPLEMENT=ind_reject,NCOMPLEMENT=n_reject)
	;
	;	Low-P and faint
	;
	ind_LowP = WHERE(mH le (*PTR).max_mag $
				and  psnr lt (*PTR).min_psnr $
        and  sP le (*PTR).max_sp,n_LowP)
	ind_faint = WHERE(sP gt (*PTR).max_sp $
            or    mH gt (*PTR).max_mag,n_faint)
	;
	log2_sP = alog(sP)/alog(2.)
	ymin = min(log2_sP,MAX=ymax)
	yr = [ymin, ymax]
	dyr = ymax-ymin
	yr[0] -= 0.05*dyr
	yr[1] += 0.05*dyr
	;
	xmin = min(mH,MAX=xmax)
	xr = [xmin, xmax]
	dxr = xmax - xmin
	xr[0] -= 0.05*dxr
	xr[1] += 0.05*dxr
	;
	;
	plot, xr, yr,xr=xr,xs=1,yr=yr,ys=17,/nodata,$
		xtitle='H-Band Mag.',ytitle=yt,$
		thick=pthick,color=white,charsize=chsz,xtickinterval=1,ytickinterval=1,$
		xminor=2,yminor=2,xmar=xmar,ymar=ymar,xthick=pthick,ythick=pthick,xcharsize=chsz,ycharsize=chsz
	;
	if(n_select ne 0) then oplot, mH[ind_select],log2_sP[ind_select],psym=4, symsize=0.5*chsz, $
							thick=pthick, color=(*PTR).color_t2_selected
	;
	if(n_LowP ne 0) then oplot, mH[ind_LowP],log2_sP[ind_LowP],psym=4, symsize=0.5*chsz, $
							thick=pthick, color=(*PTR).color_t2_lowP
	if(n_faint ne 0) then oplot, mH[ind_faint],log2_sP[ind_faint],psym=4, symsize=0.5*chsz, $
							thick=pthick, color=(*PTR).color_t2_faint
	;
	oplot, [1,1]*(*PTR).max_mag,yr,psym=-3, symsize=0.002, thick=pthick, linestyle=1, color=(*PTR).color_dividers
	oplot, xr, [1,1]*alog((*PTR).max_sP)/alog(2.),psym=-3, symsize=0.002, linestyle=1,thick=pthick, color=(*PTR).color_dividers
	;
	plot, xr, yr,xr=xr,xs=1,yr=yr,ys=17,/nodata,/noerase,$
		xtitle='H-Band Mag.',ytitle=yt,$
		thick=pthick,color=white,charsize=chsz,xtickinterval=1,ytickinterval=1,$
		xminor=2,yminor=2,xmar=xmar,ymar=ymar,xthick=pthick,ythick=pthick,xcharsize=chsz,ycharsize=chsz
	;
	if(type eq 1) then begin
		;
		;	close the plot file and return to WIN mode
		;
		DEVICE,/CLOSE
		;
		SET_PLOT, (*PTR).win_type
		;
		zprint,Event,"Postscript File Written to Disk"
	endif
end
;
;----------------------------------------------------------------
pro Plot_PSNR_vs_mH, Event, type
	;
	;	creates the PSNR vs mH plot
	;
	;	if type = 0, sends it to the current window
	;	if type = 1, sends it to the output file (PS plot) and then resets to current WIN mode
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	if(type eq 1) then begin
		;
		;	capture current window type
		;
		SET_PLOT, 'PS'
		!P.FONT=1
		DEVICE, /TIMES, FONT_SIZE=13, /PORTRAIT, /ENCAPSUL, /COLOR, $
				XSIZE=24, YSIZE=22
		;
		DEVICE, FILENAME=(*PTR).ps_out
		;chsz = 2.25
		chsz = 1.4    ; 20210623
		thick=4
		pthick = 6
		xmar = [7,3]
		ymar = [10.2]
		;
		yt ='Log!D2!N(PSNR)'
;		(*PTR).ps_thick=ps_thick
;		(*PTR).chsz = chsz
;		(*PTR).thick = thick
		;
	endif
	;
	;
	if(type eq 0) then begin
		plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
		xyouts, 0.5, 0.5, 'Ready Window 1',alignment=0.5
		pthick=1
		chsz=1.3
		xmar = [8,1.5]
		ymar = [4,1]
		yt ='Base 2 Log of PSNR'
		erase
	endif
	;
	stokes_u = (*(*PTR).polcat_data).s.u
	stokes_q = (*(*PTR).polcat_data).s.q
	sP = (*(*PTR).polcat_data).s.sP
	mH = (*(*PTR).polcat_data).s.H_mag
	;
	psnr = sqrt(stokes_u^2 + stokes_q^2) / sP
	;
	ind_select = WHERE(mH le (*PTR).max_mag $
					and sP le (*PTR).max_sp $
					and psnr ge (*PTR).min_psnr,n_select,$
				COMPLEMENT=ind_reject,NCOMPLEMENT=n_reject)
	;
	;	upper limits and false positives
	;
	ind_upper = WHERE(mH le (*PTR).max_mag and sP le (*PTR).max_sp and psnr lt (*PTR).min_psnr,n_upper)
	ind_false = WHERE(mH gt (*PTR).max_mag and sP le (*PTR).max_sp and psnr ge (*PTR).min_psnr,n_false)
	;
	;	Low-P and faint
	;
	ind_LowP = WHERE(mH le (*PTR).max_mag $
				and  psnr lt (*PTR).min_psnr $
				and  sP le (*PTR).max_sp,n_LowP)
	ind_faint = WHERE(sP gt (*PTR).max_sp $
	            or    mH gt (*PTR).max_mag,n_faint)
	;
	;
	xmin = min(mH,MAX=xmax)
	xr = [xmin, xmax]
	dxr = xmax - xmin
	xr[0] -= 0.05*dxr
	xr[1] += 0.05*dxr
	;
	log2_PSNR = alog(psnr)/alog(2.)
	;
	ymin = min(log2_PSNR,MAX=ymax)
	yr = [ymin, ymax]
	dyr = ymax - ymin
	yr[0] -= 0.05*dyr
	yr[1] += 0.05*dyr
	;
	plot, xr, yr,xr=xr,xs=1,yr=yr,ys=17,/nodata,$
		xtitle='H-Band Mag.',ytitle=yt,$
		thick=pthick,color=white,charsize=chsz,xtickinterval=1,ytickinterval=1,$
		xminor=2,yminor=2,xmar=xmar,ymar=ymar,xthick=pthick,ythick=pthick,xcharsize=chsz,ycharsize=chsz
	;
	if(n_select ne 0) then oplot, mH[ind_select],log2_PSNR[ind_select],psym=4, symsize=0.5*chsz, $
							thick=pthick,color=(*PTR).color_t2_selected
	;
	if(n_LowP ne 0) then oplot, mH[ind_LowP],log2_PSNR[ind_LowP],psym=4, symsize=0.5*chsz, $
							thick=pthick,color=(*PTR).color_t2_lowP
	if(n_faint ne 0) then oplot, mH[ind_faint],log2_PSNR[ind_faint],psym=4, symsize=0.5*chsz, $
							thick=pthick,color=(*PTR).color_t2_faint
	;
	oplot, [1,1]*(*PTR).max_mag,yr,psym=-3, symsize=0.002, thick=pthick, linestyle=1, color=(*PTR).color_dividers
	oplot, xr, [1,1]*(alog((*PTR).min_psnr)/alog(2.)),psym=-3, symsize=0.002, linestyle=1, thick=pthick, color=(*PTR).color_dividers
	;
	plot, xr, yr,xr=xr,xs=1,yr=yr,ys=17,/nodata,/noerase,$
		xtitle='H-Band Mag.',ytitle=yt,$
		thick=pthick,color=white,charsize=chsz,xtickinterval=1,ytickinterval=1,$
		xminor=2,yminor=2,xmar=xmar,ymar=ymar,xthick=pthick,ythick=pthick,xcharsize=chsz,ycharsize=chsz
	;
	if(type eq 1) then begin
		;
		;	close the plot file and return to WIN mode
		;
		DEVICE,/CLOSE
		;
		SET_PLOT, (*PTR).win_type
		;
		zprint,Event,"Postscript File Written to Disk"
	endif
end
;
;-----------------------------------------------------------------
pro Print_PSNR_vs_Mag, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	(*PTR).ps_out = dialog_pickfile(title='Name of Postscript Plot file to Save')
	;
	type = 1
	Plot_PSNR_vs_mH, Event, type
	;
end
;
;-----------------------------------------------------------------
pro Print_sP_vs_Mag, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	(*PTR).ps_out = dialog_pickfile(title='Name of Postscript Plot file to Save')
	;
	type = 1
	Plot_sP_vs_mH, Event, type
	;
end
;
;-----------------------------------------------------------------
pro Set_Mag_Limit, Event
	;
	text_box_name = 'Text_Mag_Limit'
	;
	Change_textbox, Event, text_box_name
   ;
end
;
;-----------------------------------------------------------------
pro Set_PSNR_Limit, Event
	;
	text_box_name = 'Text_PSNR_Limit'
	;
	Change_textbox, Event, text_box_name
	;
end
;
;-----------------------------------------------------------------
pro Set_sP_Limit, Event
	;
	text_box_name = 'Text_sP_Limit'
	;
	Change_textbox, Event, text_box_name
	;
end
;
;-----------------------------------------------------------------
pro Change_textbox, Event, text_box_name
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	;	ignore all until a CR is sensed, then get the full string
	;
	if(Event.type eq 0) then begin
		if(Event.ch eq 13B or Event.ch eq 10B) then begin
			;
			WIDGET_CONTROL, Event.id, GET_VALUE=str
			;
			;	check length of string, if zero, then send back default value
			;
			ch_len = STRLEN(str)
			if(ch_len eq 0) then begin
				;
				case text_box_name of
					'Text_Mag_Limit': begin
										(*PTR).max_mag = 13.3
										this_val = 13.3
					                  end
					'Text_PSNR_Limit' : begin
										 (*PTR).min_psnr = 2.0
										 this_val = 2.0
										end
					'Text_sP_Limit':	begin
										 (*PTR).max_sp = 1.0
										 this_val = 1.0
										end
					'Text_Plot_Offset':	begin
										 (*PTR).offset=2.0
										 this_val = 2.0
										end
					'Text_Plot_Range':  begin
										 (*PTR).range = 3.0
										 this_val = 3.0
										end
				endcase
				;
				WIDGET_CONTROL, Event.id, SET_VALUE=STRING(this_val, format='(F8.2)')
				;
			endif else begin
				;
				;	else, echo and parse the string
				;
	;			print, 'redshift - echo str = ',str
				;
				;	read the string to get the new redshift
				;
				reads, str, new_value, format='(F)'
				;
				case text_box_name of
					'Text_Mag_Limit': begin
										(*PTR).max_mag = new_value
					                  end
					'Text_PSNR_Limit' : begin
										 (*PTR).min_psnr = new_value
										end
					'Text_sP_Limit':	begin
										 (*PTR).max_sp = new_value
										end
					'Text_Plot_Offset': begin
										 (*PTR).offset = new_value
										end
					'Text_Plot_Range':  begin
										 (*PTR).range = new_value
										end
				endcase
				;
				WIDGET_CONTROL, Event.id, SET_VALUE=STRING( new_value, format='(F8.2)')
				;
			endelse
			;
			;	which tab is current?
			;
			wid_tab = WIDGET_INFO(Event.top, FIND_BY_UNAME="PPT_Tabs")
			this_tab = WIDGET_INFO( wid_tab, /TAB_CURRENT)
			;
			case this_tab of
				0:
				1: Tab_2_Handler, Event	; redraw Tab 2 info
				2:
				3: Tab_4_Handler, Event
			endcase
			;
		endif else begin
			;print, 'not CR, instead = ',Event.ch
		endelse
	endif
end
;
;
;-----------------------------------------------------------------
pro Write_Selected_Data, Event
	;
	;	write the data selected via the criteria as a "POLCAT" form, with a suitable header
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	(*PTR).file_out = dialog_pickfile(title="File name for selected stars POLCAT",path=ppol_dir)
	;
	;	add selection information to the header
	;
	descriptor = STRING((*PTR).max_mag,(*PTR).min_psnr,(*PTR).max_sp,$
			format='("Stars meeting criteria: Mag =< ",F6.2,", PSRN >= ",F6.2,", sP =< ",F6.2)')
	;
	index = (*PTR).ind_select[0:((*PTR).n_select-1)]
	;
	ppt_write_polcat, Event, descriptor, index
	;
end
;
;-----------------------------------------------------------------
pro Write_Rejected_Data, Event
	;
	;	write the data rejected via the criteria as a "POLCAT" form, with a suitable header
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	(*PTR).file_out = dialog_pickfile(title="File name for rejected stars POLCAT",path=ppol_dir)
	;
	;	add selection information to the header
	;
	descriptor = STRING((*PTR).max_mag,(*PTR).min_psnr,(*PTR).max_sp,$
			format='("Stars not meeting criteria: Mag =< ",F6.2,", PSRN >= ",F6.2,", sP =< ",F6.2)')
	;
	index = (*PTR).ind_reject[0:((*PTR).n_reject-1)]
	;
	ppt_write_polcat, Event, descriptor, index
	;
end
;
;-----------------------------------------------------------------
pro Select_Reference_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Reference_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting reference vector color to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_reference = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_Reference_Length, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Reference_Length")
	;
	length_index = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting reference vector length to '+(*PTR).reference_lengths[length_index]
	;
	(*PTR).reference_length_index = length_index
	;
end
;
;-----------------------------------------------------------------
pro Select_Vector_Thickness, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Vector_Thickness")
	;
	thickness_index = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting vector thickness to '+(*PTR).vector_thicknesses[thickness_index]
	;
	(*PTR).vector_thickness_index = thickness_index
	;
end
;
;-----------------------------------------------------------------
pro Select_Vector_Length, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Vector_Length")
	;
	length_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting vector length to '+(*PTR).vector_lengths[length_number]
	;
	(*PTR).vector_length_index = length_number
	;
end
;
;-----------------------------------------------------------------
pro Toggle_Length_Pol, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id_uni = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Uniform")
	wid_id_pol = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Pol")
	wid_id_log = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Log")
	;
	WIDGET_CONTROL, wid_id_uni, SET_BUTTON=0
	WIDGET_CONTROL, wid_id_pol, SET_BUTTON=1
	WIDGET_CONTROL, wid_id_log, SET_BUTTON=0
	;
	(*PTR).uniform_length_flag = 0
	(*PTR).pol_length_flag = 1
	(*PTR).pol_log_flag = 0
	;
	zprint,event,'Setting Vector Length to Polarization Percentage'
	;
end
;
;-----------------------------------------------------------------
pro Toggle_Length_Uniform, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id_uni = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Uniform")
	wid_id_pol = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Pol")
	wid_id_log = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Log")
	;
	WIDGET_CONTROL, wid_id_uni, SET_BUTTON=1
	WIDGET_CONTROL, wid_id_pol, SET_BUTTON=0
	WIDGET_CONTROL, wid_id_log, SET_BUTTON=0
	;
	(*PTR).uniform_length_flag = 1
	(*PTR).pol_length_flag = 0
	(*PTR).pol_log_flag = 0
	;
	zprint,event,'Setting Vector Length to Uniform'
	;
end
;
;-----------------------------------------------------------------
pro Toggle_Length_Log, Event
  WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
  ;
  wid_id_uni = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Uniform")
  wid_id_pol = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Pol")
  wid_id_log = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Length_Log")
  ;
  WIDGET_CONTROL, wid_id_uni, SET_BUTTON=0
  WIDGET_CONTROL, wid_id_pol, SET_BUTTON=0
  WIDGET_CONTROL, wid_id_log, SET_BUTTON=1
  ;
  (*PTR).uniform_length_flag = 0
  (*PTR).pol_length_flag = 0
  (*PTR).pol_log_flag = 1
  ;
  zprint,event,'Setting Vector Length to Log(P)'
  ;
end
;
;-----------------------------------------------------------------
pro Select_PSNR_2, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_2")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting PSNR>2 vector color to '+(*PTR).color_names[color_number]
	;
	(*PTR).colors_PSNR[1] = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_PSNR_3, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_3")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting PSNR>3 vector color to '+(*PTR).color_names[color_number]
	;
	(*PTR).colors_PSNR[2] = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_PSNR_5, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_5")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting PSNR>5 vector color to '+(*PTR).color_names[color_number]
	;
	(*PTR).colors_PSNR[3] = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_PSNR_7, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_7")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting PSNR>7 vector color to '+(*PTR).color_names[color_number]
	;
	(*PTR).colors_PSNR[4] = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_PSNR_10, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_10")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting PSNR>10 vector color to '+(*PTR).color_names[color_number]
	;
	(*PTR).colors_PSNR[5] = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_Uniform_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Uniform_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting uniform vector color to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_uniform = color_number
	;
end
;
;-----------------------------------------------------------------
pro Toggle_Color_PSNR, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id_uni = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Color_Uniform")
	wid_id_psnr = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Color_PSNR")
	;
	WIDGET_CONTROL, wid_id_uni, SET_BUTTON=0
	WIDGET_CONTROL, wid_id_psnr, SET_BUTTON=1
	;
	(*PTR).color_uniform_flag = 0
	(*PTR).color_PSNR_flag = 1
	;
	zprint,event,'Setting vector colors to vary with PSNR'
	;
end
;
;-----------------------------------------------------------------
pro Toggle_Color_Uniform, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id_uni = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Color_Uniform")
	wid_id_psnr = WIDGET_INFO(Event.top, FIND_BY_UNAME="Radio_Color_PSNR")
	;
	WIDGET_CONTROL, wid_id_uni, SET_BUTTON=1
	WIDGET_CONTROL, wid_id_psnr, SET_BUTTON=0
	;
	(*PTR).color_uniform_flag = 1
	(*PTR).color_PSNR_flag = 0
	;
	zprint,event,'Setting vector colors to be uniform'
	;
end
;
;-----------------------------------------------------------------
pro Tab_4_Handler, Event
	;
	;	landed on Tab 4
	;
	;	create the vector list, plot in the plot window
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	;	clear the plot space
	;
	plot_wid = WIDGET_INFO(Event.top, FIND_BY_UNAME='Draw_Final_Plot')
	;
	WIDGET_CONTROL, plot_wid, GET_VALUE=win
	wset, win
	erase
	plot, [0,1],[0,1],xstyle=5,ystyle=5,/nodata
	xyouts, 0.5, 0.5, 'Ready Final',alignment=0.5
	;
	;	get the vectors loaded
	;
	ppt_make_vector_draw_list, Event
	zprint, Event, 'loaded '+STRING((*PTR).n_select,format='(I)')+' vectors onto heap'
	;
	;	if there are upper limits to be plotted as circles, get them ready
	;
	if( (*PTR).show_upper_flag eq 1) then begin
		;
		ppt_make_circle_draw_list, Event
		zprint, Event, 'loaded '+STRING((*PTR).n_reject,format='(I)')+' circles onto heap'
		;
	endif
	;
	;	plot the image
	;
	iplot = 0
	ppt_plot_image,Event,iplot
	;
	pmode = 1
	;
	;
	;	if there are upper limits, plot them next
	;
	if( (*PTR).show_upper_flag eq 1) then begin
		;
		ppt_overplot_circles, Event, pmode
		zprint, Event, 'overplotted '+STRING((*PTR).n_reject,format='(I)')+' circles'
		;
	endif
	;
	;	overplot the vectors
	;
	ppt_overplot_vectors, Event, pmode
	zprint, Event, 'overplotted '+STRING((*PTR).n_select,format='(I)')+' vectors'
	;
	;	and overplot the reference vector and label
	;
	ppt_overplot_reference, Event, pmode
	;
end
;
;-----------------------------------------------------------------
function DS9_color, color
  case color of
    'gray': ocolor = '"'+'#808080'+'"'
    'gray-lt': ocolor = '"'+'#C0C0C0'+'"'
    'gray-dk': ocolor = '"'+'#505050'+'"'
    else: ocolor = color
  endcase
return, ocolor
end
;
;----------------------------------------------------------------
pro Write_DS9_Region_File, Event
	;
	;	write the current vector list and reference label to a DS9
	;	region file
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	;	first, verify that there are vectors to write
	;
	if((*PTR).n_select eq 0) then begin
		zprint, Event, 'No polarization vectors selected. No DS9 file will be written'
		goto, ds9_end
	endif
	;
	;	get the image info to find plotting limits
	;
	ncol = SXPAR((*(*PTR).header_ptr),'NAXIS1')
	nrow = SXPAR((*(*PTR).header_ptr),'NAXIS2')
	;
	xr = [0, ncol-1]
	yr = [0, nrow-1]
	extast, (*(*PTR).header_ptr), astr
	;
	file_out = dialog_pickfile(Title="DS9 Region File to Write",path=(*PTR).ppol_dir)
	;
	openw, lu_out, file_out, /GET_LUN
	;
	;	two modes - pixel coordinates or FK5 coordinates. Make user selectable?
	;
	imode = 'FK5'
	;imode = 'pixel'
	;
	printf, lu_out, '# Region file format: DS9 version 4.1'
	fmt_a = 'global color=green dashlist=8 3 width=1 font="helvetica 10 normal roman"'
	fmt_b = 'select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1'
	fmt_ab = fmt_a + fmt_b
	;
	printf, lu_out, fmt_ab

	if(imode eq 'pixel') then printf, lu_out, 'image'
	if(imode eq 'FK5') then printf, lu_out, 'fk5'
	;
	;	put upper limits in first, if they are present
	;
	if( (*PTR).show_upper_flag eq 1) then begin
		n_reject = (*PTR).n_reject
		;
		for i = 0, n_reject-1 do begin
			;
			if(imode eq 'pixel') then begin
				x_cen = (*(*PTR).circles_ptr)[i].x_cen
				y_cen = (*(*PTR).circles_ptr)[i].y_cen
				rad = (*(*PTR).circles_ptr)[i].circ_radius
				;
				; circle(461,663,10.699121) # color=white width=2
				fmt = '("circle(",f6.1,",",f6.1,",",f10.6,") # color= ",a," width= ",I1)'
				;
			endif
			;
			if(imode eq 'FK5') then begin
				x_cen = (*(*PTR).circles_ptr)[i].ra_cen
				y_cen = (*(*PTR).circles_ptr)[i].dec_cen
				pscale = 0.58		; arcsec per pixel
				rad = (*(*PTR).circles_ptr)[i].circ_radius * pscale
				;
				; circle(70.4094675,25.6575840,11.576") # color=white width=2
				fmt = '("circle(",f11.7,",",f11.7,",",f7.3,1H",") # color= ",a," width= ",I1)'
				;
			endif
			;
			circ_color = (*(*PTR).circles_ptr)[i].circ_color
			circ_thick = (*(*PTR).circles_ptr)[i].circ_thick
			;
			printf, lu_out, x_cen, y_cen, rad, ds9_color(circ_color), circ_thick, $
				format=fmt
			;
		endfor
	endif
	;
	;	vectors next
	;
	n_select = (*PTR).n_select
	;
	for i = 0, n_select-1 do begin
		;
		if(imode eq 'pixel') then begin
			x_0 = (*(*PTR).vectors_ptr)[i].x_0
			y_0 = (*(*PTR).vectors_ptr)[i].y_0
			x_1 = (*(*PTR).vectors_ptr)[i].x_1
			y_1 = (*(*PTR).vectors_ptr)[i].y_1
			;
			;	check that each point is within the image plotting limits
			;
			;	which endpoint is bad (first, last, or both)
			;
			bad = 0
			if(x_0 lt xr[0] or x_0 gt xr[1] or y_0 lt yr[0] or y_0 gt yr[1]) then bad += 1
			if(x_1 lt xr[0] or x_1 gt xr[1] or y_1 lt yr[0] or y_1 gt yr[1]) then bad += 2
			if(bad gt 0) then begin
				;
				;	OK, at least one coordinate is outside the plotting range
				;
				;	start by determining the equation of the line
				;
				slope = (y_1 - y_0) / (x_1 - x_0)
				x_cen = (x_1 + x_0) / 2.
				y_cen = (y_1 + y_0) / 2.
				;
				;		y = y_cen + (x - x_cen) * slope
				;
				case bad of
					1: begin
						;
						;	first endpoint is bad
						;
						;	locate which coordinate(s) it is bad in and fix end point
						;
						fix_endpoint, ncol, nrow, x_cen, y_cen, slope, x_0, y_0
						;
					   end
					2: begin
						;
						;	second endpoint is bad
						;
						fix_endpoint, ncol, nrow, x_cen, y_cen, slope, x_1, y_1
						;
					   end
					3: begin
						;
						;	both endpoints are bad
						;
						fix_endpoint, ncol, nrow, x_cen, y_cen, slope, x_0, _0
						fix_encpoint, ncol, nrow, x_cen, y_cen, slope, x_1, y_1
					   end
				endcase
				;
			endif
			;# Region file format: DS9 version 4.1
			;global color=green dashlist=8 3 width=1 font="helvetica 10 normal roman"
			;select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1
			;image
			;line(371.12214,920.80153,421.27481,858.94656) # line=0 0
			;
			fmt = '("line(",f6.1,",",f6.1,",",f6.1,",",f6.1,") # line=0 0 color= ",a," width= ",I1)'
		endif
		;
		if(imode eq 'FK5') then begin
;			x_0 = (*(*PTR).vectors_ptr)[i].ra_0
;			y_0 = (*(*PTR).vectors_ptr)[i].dec_0
;			x_1 = (*(*PTR).vectors_ptr)[i].ra_1
;			y_1 = (*(*PTR).vectors_ptr)[i].dec_1
			;
			;	convert to pixel space to do testing
			;
			ad2xy, (*(*PTR).vectors_ptr)[i].ra_0, (*(*PTR).vectors_ptr)[i].dec_0, astr, x_0, y_0
			ad2xy, (*(*PTR).vectors_ptr)[i].ra_1, (*(*PTR).vectors_ptr)[i].dec_1, astr, x_1, y_1
			;
			bad = 0
			if(x_0 lt xr[0] or x_0 gt xr[1] or y_0 lt yr[0] or y_0 gt yr[1]) then bad += 1
			if(x_1 lt xr[0] or x_1 gt xr[1] or y_1 lt yr[0] or y_1 gt yr[1]) then bad += 2
			if(bad gt 0) then begin
				;
				;	OK, at least one coordinate is outside the plotting range
				;
				;	start by determining the equation of the line
				;
				slope = (y_1 - y_0) / (x_1 - x_0)
				x_cen = (x_1 + x_0) / 2.
				y_cen = (y_1 + y_0) / 2.
				;
				;		y = y_cen + (x - x_cen) * slope
				;
				case bad of
					1: begin
						;
						;	first endpoint is bad
						;
						;	locate which coordinate(s) it is bad in and fix end point
						;
						fix_endpoint, ncol, nrow, x_cen, y_cen, slope, x_0, y_0
						;
					   end
					2: begin
						;
						;	second endpoint is bad
						;
						fix_endpoint, ncol, nrow, x_cen, y_cen, slope, x_1, y_1
						;
					   end
					3: begin
						;
						;	both endpoints are bad
						;
						fix_endpoint, ncol, nrow, x_cen, y_cen, slope, x_0, y_0
						fix_endpoint, ncol, nrow, x_cen, y_cen, slope, x_1, y_1
					   end
				endcase
				;
			endif
			;
			;	convert back to RA, Dec for endpoints
			;
			xy2ad, x_0, y_0, astr, a_0, d_0
			xy2ad, x_1, y_1, astr, a_1, d_1
			;
			x_0 = a_0
			y_0 = d_0
			x_1 = a_1
			y_1 = d_1
			;
			;# Region file format: DS9 version 4.1
			;global color=green dashlist=8 3 width=1 font="helvetica 10 normal roman"
			;select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1
			;fk5
			;line(76.0050008,32.7721728,76.0050454,32.7603464) # line=0 0 color=cyan width=3 dash=1
			;
			fmt = '("line(",f11.6,",",f11.6,",",f11.6,",",f11.6,") # line=0 0 color= ",a," width= ",I1)'
		endif
		;
		vec_color = (*(*PTR).vectors_ptr)[i].vec_color
		vec_thick = (*(*PTR).vectors_ptr)[i].vec_thick
		;
		printf, lu_out, x_0, y_0, x_1, y_1, ds9_color(vec_color), vec_thick, $
			format=fmt
		;
	endfor
	;
	;	write reference vector if its length is non-zero
	;
	if((*(*PTR).vectors_ptr)[n_select].vec_length ne 0.0) then begin
		this_ref_label = (*PTR).reference_lengths[(*PTR).reference_length_index]
		;
		if(imode eq 'pixel') then begin
			x_0 = (*(*PTR).vectors_ptr)[n_select].x_0
			y_0 = (*(*PTR).vectors_ptr)[n_select].y_0
			x_1 = (*(*PTR).vectors_ptr)[n_select].x_1
			y_1 = (*(*PTR).vectors_ptr)[n_select].y_1
			;# Region file format: DS9 version 4.1
			;global color=green dashlist=8 3 width=1 font="helvetica 10 normal roman"
			;select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1
			;image
			;line(371.12214,920.80153,421.27481,858.94656) # line=0 0
			;
			fmt = '("line(",f6.1,",",f6.1,",",f6.1,",",f6.1,") # line=0 0 color= ",a," width= ",I1,'
						fmt += '" font=",1H","helvetica 12 bold roman",1H"," text={",a,"}")'
		endif
		;
		if(imode eq 'FK5') then begin
			x_0 = (*(*PTR).vectors_ptr)[n_select].ra_0
			y_0 = (*(*PTR).vectors_ptr)[n_select].dec_0
			x_1 = (*(*PTR).vectors_ptr)[n_select].ra_1
			y_1 = (*(*PTR).vectors_ptr)[n_select].dec_1
			;# Region file format: DS9 version 4.1
			;global color=green dashlist=8 3 width=1 font="helvetica 10 normal roman"
			;select=1 highlite=1 dash=0 fixed=0 edit=1 move=1 delete=1 include=1 source=1
			;fk5
			;line(76.0050008,32.7721728,76.0050454,32.7603464) # line=0 0 color=cyan width=3 dash=1 font="helvetica 12 bold roman" text={My vector}

			;
			fmt = '("line(",f11.6,",",f11.6,",",f11.6,",",f11.6,") # line=0 0 color= ",a," width= ",I1,'
						fmt += '" font=",1H","helvetica 12 bold roman",1H"," text={",a,"}")'
		endif
		;
		this_color = (*(*PTR).vectors_ptr)[n_select].vec_color
		this_thick = (*(*PTR).vectors_ptr)[n_select].vec_thick
		;
		printf, lu_out, x_0, y_0, x_1, y_1, ds9_color(this_color), this_thick, this_ref_label, $
			format=fmt
	endif
	;
	FREE_LUN, lu_out
	;
	zprint, Event, 'Wrote '+STRING(n_select,format='(I)')+' vectors to DS9 region file'
	;
	ds9_end:
end
;
;-----------------------------------------------------------------
pro Write_Postscript_File, Event
	;
	;	writes the current plot to a postscript file
	;	(actually regenerates the plot to the file)
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	(*PTR).ps_out = dialog_pickfile(Title='Output Postscript Plot file',path=(*PTR).ppol_dir)
	;
	;	plot the image
	;
	iplot = 1
	;
	ppt_plot_image,Event,iplot
	;
	pmode = 1					; RA, dec
	;
	;	if there are upper limits, plot them next
	;
	if( (*PTR).show_upper_flag eq 1) then begin
		;
		ppt_overplot_circles, Event, pmode
;		zprint, Event, 'overplotted '+STRING((*PTR).n_reject,format='(I)')+' circles'
		;
	endif
	;
	;	overplot the vectors
	;
	ppt_overplot_vectors, Event, pmode
	;
	;	and overplot the reference vector and label
	;
	ppt_overplot_reference, Event, pmode
	;
	;	and close the plot file
	;
	DEVICE,/CLOSE
	;
	SET_PLOT, (*PTR).win_type
	;
	zprint,Event,"Postscript File Written to Disk"
	;
	;	replot to screen
	;
	Tab_4_Handler, Event
	;
end

;-----------------------------------------------------------------
pro Final_Plot_Handler, Event
	;
	;	TBD stub. Could return star details via cursor
	;
end
;
;-----------------------------------------------------------------
pro Toggle_Plot_Title, Event
	;
	;	toggle the option to print the image filename as a plot title
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME='Button_Plot_Title')
	;
	this_flag = (*PTR).plot_title_flag
	(*PTR).plot_title_flag = 1 - this_flag
	;
	WIDGET_CONTROL, wid_id, SET_BUTTON=(*PTR).plot_title_flag
	;
	if((*PTR).plot_title_flag eq 0) then begin
		zprint, Event, "Turning off filename title printing"
	endif else begin
		zprint, Event, "Turning on the filename title printing option"
	endelse
	;
	;	if the current tab is number 4, replot tab 4
	;
	wid_id = WIDGET_INFO( Event.top, FIND_BY_UNAME="PPT_Tabs")
	;
	; which tab is front?
	;
	this_tab = WIDGET_INFO( wid_id, /TAB_CURRENT)
	;
	case this_tab of
		0:
		1:
		2:
		3: Tab_4_Handler, event
	endcase
	;
end
;
;-----------------------------------------------------------------
pro Edit_Plot_Offset, Event
	;
	text_box_name = 'Text_Plot_Offset'
	;
	Change_textbox, Event, text_box_name
	;
end
;
;-----------------------------------------------------------------
pro Edit_Plot_Range, Event
	;
	text_box_name = 'Text_Plot_Range'
	;
	Change_textbox, Event, text_box_name
	;
end

;
;-----------------------------------------------------------------
pro Toggle_Show_Circles, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Checkbox_Show_Circles")
	;
	current_value = (*PTR).show_upper_flag
	new_value = 1 - current_value
	(*PTR).show_upper_flag = new_value
	;
	WIDGET_CONTROL, wid_id, SET_BUTTON=new_value
	;
	widgets = ['Checkbox_Separate_Upper_Limits','Droplist_Faint_Color',$
							'Droplist_Upper_Radius','Droplist_Upper_Thickness']
	n_widgets = N_ELEMENTS(widgets)
	;
	case new_value of
		0: 	begin
				zprint,event,'Setting to NOT show upper limits'
				;
				;	for this case make invisible all related buttons
				;
				for i = 0, n_widgets-1 do begin
					wid_id_0 = WIDGET_INFO(Event.top, FIND_BY_UNAME=widgets[i])
					WIDGET_CONTROL, wid_id_0, SENSITIVE=0
				endfor
			end
		1:  begin
				zprint,event,'Setting to show upper limits'
				;
				;	make the widgets visible
				;
				for i = 0, n_widgets-1 do begin
					wid_id_0 = WIDGET_INFO(Event.top, FIND_BY_UNAME=widgets[i])
					WIDGET_CONTROL, wid_id_0, SENSITIVE=1
				endfor
			end
	endcase
	;
end
;
;-----------------------------------------------------------------
pro Toggle_Split_Upper_Limits, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Checkbox_Separate_Upper_Limits")
	;
	current_value = (*PTR).split_LowP_Faint_flag
	new_value = 1 - current_value
	;
	WIDGET_CONTROL, wid_id, SET_BUTTON=new_value
	;
	(*PTR).split_LowP_Faint_flag = new_value
	;
	widgets = ['Droplist_High_LowP_Color','Droplist_Med_LowP_Color',$
							'Droplist_Low_LowP_Color']
	n_widgets = N_ELEMENTS(widgets)
	;
	case new_value of
		0: 	begin
				zprint,event,'Setting to NOT separate upper limits into LowP and Faint stars'
				;
				for i = 0, n_widgets-1 do begin
					wid_id_0 = WIDGET_INFO(Event.top, FIND_BY_UNAME=widgets[i])
					WIDGET_CONTROL, wid_id_0, SENSITIVE=0
				endfor
			end
		1:  begin
				zprint,event,'Setting to separate upper limits into LowP and Faint stars'
				for i = 0, n_widgets-1 do begin
					wid_id_0 = WIDGET_INFO(Event.top, FIND_BY_UNAME=widgets[i])
					WIDGET_CONTROL, wid_id_0, SENSITIVE=1
				endfor
			end
	endcase
	;
end
;
;-----------------------------------------------------------------
pro Select_Faint_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Faint_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting Faint/All upper limits color to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_faint = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_High_LowP_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_High_LowP_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting High SNR LowP upper limits color to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_LowP_high = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_Med_LowP_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Med_LowP_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting Medium SNR LowP upper limits color to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_LowP_med = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_Low_LowP_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Low_LowP_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting Low SNR LowP upper limits color to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_LowP_low = color_number
	;
end
;
;-----------------------------------------------------------------
pro Select_Upper_Radius, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Upper_Radius")
	;
	length_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting upper limit radius to '+(*PTR).circle_radii[length_number]
	;
	(*PTR).circle_radius_index = length_number
	;
end
;
;-----------------------------------------------------------------
pro Select_Upper_Thickness, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Upper_Thickness")
	;
	thickness_index = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting upper limit thickness to '+(*PTR).circle_thicknesses[thickness_index]
	;
	(*PTR).circle_thickness_index = thickness_index
	;
end
;
;-----------------------------------------------------------------
pro sP_Plot_Handler, Event
	; stub, needed, don't delete
end
;
;-----------------------------------------------------------------
pro PSNR_Plot_Handler, Event
	; stub, needed, don't delete
end
;
;-----------------------------------------------------------------
pro Select_B_Image, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	;	directly select the image for loading from the file system
	;
	image_path = dialog_pickfile(titl='Select FITS Image to load')
	;
	(*(*PTR).image_ptr) = readfits(image_path,header)
	(*(*PTR).header_ptr) = header
	(*PTR).image_read_flag = 1L
	(*PTR).image_name = FILE_BASENAME(image_path,'.fits')
	;
	zprint,event,'Image '+(*PTR).image_name+' read in'
	;
end
;
;-----------------------------------------------------------------
pro Select_B_Directory, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	;	directly set the home directory for POLCATs.
	;
	ppol_dir = dialog_pickfile(title='Select PPOL Directory',/dir)
	;
	(*PTR).ppol_dir = ppol_dir
	;
end
;
;-----------------------------------------------------------------
pro Select_T2_Selected_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_T2_Selected_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting color of selected stars to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_t2_selected = color_number
	;
	Tab_2_Handler, Event
	;
end
;
;-----------------------------------------------------------------
pro Select_T2_LowP_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_T2_LowP_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting color of rejected Low-P stars to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_t2_lowP = color_number
	;
	Tab_2_Handler, Event
	;
end
;
;-----------------------------------------------------------------
pro Select_T2_Faint_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_T2_Faint_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting color of rejected Faint stars to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_t2_faint = color_number
	;
	Tab_2_Handler, Event
	;
end
;
;-----------------------------------------------------------------
pro Select_Divider_Color, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_Divider_Color")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting color of dividing lines to '+(*PTR).color_names[color_number]
	;
	(*PTR).color_dividers = color_number
	;
	Tab_2_Handler, Event
	;
end
;
;-----------------------------------------------------------------
pro Select_PSNR_lt_2, Event
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	wid_id = WIDGET_INFO(Event.top, FIND_BY_UNAME="Droplist_PSNR_lt_2")
	;
	color_number = WIDGET_INFO(wid_id, /DROPLIST_SELECT)
	;
	zprint,event,'Setting color of PSNR < 2 stars to '+(*PTR).color_names[color_number]
	;
	(*PTR).colors_PSNR[0] = color_number
	;
end
