pro fix_endpoint, ncol, nrow, x_cen, y_cen, slope, x_0, y_0
;
;	tests the endpoint against the image limits.
;	if the point is outside, then follow the slope of its
;	line to put it back inside the limits and reset the
;	x,y values.
;
;	works in X space first, then Y space
;
;	DPC	20200823
;
;	equations of the line from x_cen, y_cen to x,y:
;		y = y_cen + (x-x_cen) * slope
;		x = x_cen + (y-y_cen)/slope
;
;----------------------------------------------------------
;
;	test X limits first
;
if(x_0 lt 0) then begin
	;
	;	x is off left side of image
	;
	;	if x is to be, say, 1 pixel in, what is the corresponding y value?
	;
	x_0 = 1
	y_0 = y_cen + (x_0 - x_cen) * slope
endif
;
if(x_0 gt ncol-1) then begin
	;
	x_0 = ncol-2
	y_0 = y_cen + (x_0 - x_cen) * slope
endif
;
;	then Y
;
if(y_0 lt 0) then begin
	;
	y_0 = 1
	x_0 = x_cen + (y_0 - y_cen)/slope
endif
;
if(y_0 gt nrow-1) then begin
	;
	y_0 = nrow-2
	x_0 = x_cen + (y_0 - y_cen)/slope
endif
;
;	updated values are returned, in place
;
end