pro make_ds9_region_file, Event
	;
	;	creates a region file for the indicated image from the indicated
	;	combined pol file (not POLCAT type)
	;
	;	20200128 modified from make_region_file.pro
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
    ;
;
readcol, file, RA,Dec,H,sH,P,sP,PA,sPA,q,sq,u,su,n,d,J,sJ,H,sH,K,sK,$
			format='(d,d,d,d,d,d,d,d,d,d,d,d,a,a,d,d,d,d,d,d)',skipline=1
;
nstars = N_ELEMENTS(RA)
	;
	;	get the image header information into an astrometry array
	;
	extast,(*(*PTR).header_ptr),astr
;
outfile = dialog_pickfile(title='Output Region File')
;
openw, lu_out, outfile, /GET_LUN
;
nstars = N_ELEMENTS(RA)
;
;	for each star
;
c_scale = 9.0		; Mimir scale
length = 20.0		; Mimir scale
;
for i = 0, nstars-1 do begin
	;
	;	location of center in image
	;
	a = RA[i]
	d = Dec[i]
	;
	ad2xy, a, d, astr, xcen, ycen
	;
	;	adjust to DS9 pixel coords
	;
	xcen += 2.5
	ycen += 2.5
	;
	;	upper limit or vector?
	;
	if(P[i] eq 0.0) then begin
		;
		;	upper limit
		;
		if(bw_flag eq 1) then color = 'black' else color = 'blue'
		if(show_upper eq 1) then ds9_draw_circle, lu_out, xcen, ycen, c_scale, color,1
		;
		if(sP[i] lt 1.0 and sP[i] ge 0.5 and H[i] lt 15.0) then begin
			if(bw_flag eq 1) then color='black' else color='blue'
			if(show_upper eq 1) then ds9_draw_circle, lu_out, xcen, ycen, c_scale, color,1
		endif
		;
		if(sP[i] lt 0.1) then begin
			case bw_flag of
				0: begin
					color='magenta'
					thick = 4
				   end
				else: begin
					color='black'
					thick=3
				       end
			endcase
			if(show_upper eq 1) then ds9_draw_circle, lu_out, xcen, ycen, 1.5*c_scale, color,thick
		endif else begin
			if(sP[i] lt 0.2) then begin
				case bw_flag of
					0: begin
						color='yellow'
						thick = 3
					   end
					else: begin
						color='black'
						thick = 2
						  end
				endcase
				if(show_upper eq 1) then ds9_draw_circle, lu_out, xcen, ycen, 1.2*c_scale, color,thick
			endif else begin
				if(sP[i] lt 0.3) then begin
					case bw_flag of
						0: begin
							color='cyan'
							thick = 2
						   end
						else: begin
							color='black'
							thick=1
								end
					endcase
					if(show_upper eq 1) then ds9_draw_circle, lu_out, xcen, ycen, c_scale, color,thick
				endif else begin
					if(sP[i] lt 0.5) then begin
						case bw_flag of
							0: begin
								color='green'
								thick=2
							   end
							else: begin
								color='black'
								thick=1
								  end
						endcase
						if(show_upper eq 1) then ds9_draw_circle, lu_out, xcen, ycen, c_scale, color,thick
					endif
				endelse
			endelse
		endelse
		;
	endif else begin
		;
		;	vector
		;
		SNR = P[i]/sP[i]
		;
		if(SNR lt 1.00 and H[i] le 15.0 and show_upper eq 1) then begin
			case bw_flag of
				0: begin
					color = 'blue'
					thick=1
				   end
				else: begin
					color='black'
					thick=1
					  end
			endcase
			ds9_draw_circle, lu_out, xcen, ycen, c_scale, color,thick
		endif
		if(SNR ge 1.00 and SNR le 1.33 and H[i] le 15.0 and show_upper eq 1) then begin
			case bw_flag of
				0: begin
					color = 'magenta'
					thick=1
				   end
				else: begin
					color='black'
					thick=1
					  end
			endcase
			ds9_draw_circle, lu_out, xcen, ycen, c_scale, color,thick
		endif
		;
		case bw_flag of
			0: begin
				thick=0						; default for upper limit
				if(SNR ge 1.33) then begin
					thick=1
					color='blue'
				endif
				if(SNR ge 1.5) then begin
					thick=1
					color='blue'
				endif
				if(SNR gt 2.0) then begin
					thick=2
					color='green'
				endif
		;		if(SNR gt 2.5) then begin
		;			thick=3
		;			color='green'
		;		endif
				if(SNR gt 3.0) then begin
					thick=4
					color='cyan'
				endif
				if(SNR gt 4.0) then begin
					thick=5
					color='yellow'
				endif
				if(SNR gt 4.0) then begin
					thick=6
					color='yellow'
				endif
				;
				;
			  end
		   else: begin
		   			color='black'
		   			if(SNR gt 3.0) then thick=3 else begin
		   				if(SNR gt 1.5) then thick = 1 else thick = 0
		   			endelse
		   		 end
		endcase
		if(show_upper eq 1 and SNR lt 1.33) then goto, skip_vec
		if(show_upper eq 0 and P[i] gt 9.0) then goto, skip_vec
		if(show_upper eq 1 and P[i] gt 10.0) then goto, skip_vec
		;
		if(thick ne 0) then ds9_draw_vector, lu_out, xcen, ycen, PA[i], P[i]*length, thick, color
		;
		skip_vec:
	endelse
endfor
;
;	reference vector
;
ds9_draw_vector, lu_out, 880, 100, 90.0, 2.0*length, 4, 'red', TEXT='2% Pol.'
;
FREE_LUN, lu_out
;
print, 'Done!'
end