pro ppt_compute_means, Q, sQ, U, sU, Qx, sQx, Ux, sUx, Px, sPx, PAx, sPAx
;
;	computes uncertainty weighted means and polarization quantities from
;	the vector Q, U and their uncertainties.
;
;	DPC	20111228
;
Qt = Q/(sQ * sQ)
Qwt = 1./(sQ * sQ)
Ut = U/(sU * sU)
Uwt = 1./(sU * sU)
;
Qx = TOTAL(Qt) / TOTAL(Qwt)
sQx = 1.0 / sqrt(TOTAL(Qwt))
Ux = TOTAL(Ut) / TOTAL(Uwt)
sUx = 1.0 / sqrt(TOTAL(Uwt))
;
ng = N_ELEMENTS(Q)
;if(ng eq 4 and sQx lt 0.15) then stop
;
P_raw = sqrt(Qx * Qx + Ux * Ux)
Uunc = ABS(sUx * Ux)
Qunc = ABS(sQx * Qx)
;
sPx = (1./P_raw) * sqrt( (Uunc)^2 + (Qunc)^2)  ; trap at 0.3% to prevent blow up of uncerts.
;
pr = sPx / P_raw
if(pr gt 1.0) then begin
	Px = 0.0
	sPAx = 180.0
	PAx = 0.0
endif else begin
	Px = P_raw * sqrt(1.0 - (pr)^2)
	sPAx = 0 > ( (28.65 * sPx / Px) < 180.0)
	PAx = 0.5 * (180.0 / !PI) * ATAN(Ux, Qx)
	PAx = (720.0d0 + PAx) mod 180.0d0
endelse
;
end