pro ppt_overplot_circles,Event,pmode
	;
	;	overplots upper limit circles on displayed image
	;
	;	pmode = 0 - pixel coords
	;	pmode = 1 - equatorial degrees
	;
	WIDGET_CONTROL, Event.top, GET_UVALUE=PTR
	;
	n_vec = (*PTR).n_reject
	;
	if(n_vec eq 0) then goto, skip_to_end
	;
	;	for each circle, do an oplot from start to end
	;
	for i = 0, n_vec-1 do begin
		;
		if(pmode eq 0) then begin
			x_cen = (*(*PTR).circles_ptr)[i].x_cen
			y_cen = (*(*PTR).circles_ptr)[i].y_cen
			pscale = 1.0
		endif else begin
			x_cen = (*(*PTR).circles_ptr)[i].RA_cen
			y_cen = (*(*PTR).circles_ptr)[i].Dec_cen
			pscale = 1.61e-4		; pixels per degree
		endelse
		;
		;	get color, thickness
		;
		color_id = get_color(Event,(*(*PTR).circles_ptr)[i].circ_color)
		thick = (*(*PTR).circles_ptr)[i].circ_thick
		ps_thick = (*PTR).ps_thick
		;
		thick *= ps_thick
		;
		;	create a circle of the indicated radius
		;
		theta = (findgen(41)/40.)*2.0*!PI
		x_circ = cos(theta)/cos(y_cen * !PI / 180.0)
		y_circ = sin(theta)
		;
		x_plot = x_cen + x_circ * (*(*PTR).circles_ptr)[i].circ_radius * pscale
		y_plot = y_cen + y_circ * (*(*PTR).circles_ptr)[i].circ_radius * pscale
		;
		oplot, x_plot, y_plot, psym=-3, symsize=0.003, color=color_id, thick=thick
		;
	endfor
	;
skip_to_end:
;
end

